package no.ntnu.stockmeks;

import java.util.ArrayList;

import no.ntnu.stockmeks.agent.Agent;

import java.io.*;

/*
 * Class for making decision tree test data
 */
public class DecisionTreeTestData {
	Logger log = new Logger("DecicionTreeData");
	
	/*
	 * Generating arff test data and write them to file
	 */
	public void generateTestData(ArrayList<Agent> agents, StockTicker[] tickers, String filename){
		String toWrite = "";
		
		toWrite += "@RELATION meksen\n";
		
		for(int i=0;i<agents.size();i++){
			toWrite += "@ATTRIBUTE " + agents.get(i).getAgentName().replaceAll(" ","") + " {sell,hold,buy}\n";
		}
		toWrite += "@ATTRIBUTE class {SELL,HOLD,BUY}\n";
		toWrite += "\n@DATA";
		String[] signalText = {"sell","hold","buy"}; 
		
		

		int numDays = 0;
		int startAtDay = 30;
		
		try{
			FileWriter fw = new FileWriter(filename);
			BufferedWriter bw = new BufferedWriter(fw);
			
			bw.write(toWrite);
			

			for(int i=0;i<tickers.length;i++){
				
				numDays += tickers[i].getSize();
				
				int[] fitness = tickers[i].evaluateSignals();
				for(int k=startAtDay;k<fitness.length;k++){
					String evalLine = "";
					
					for(int j=0;j<agents.size();j++){
						int signal = agents.get(j).getSignal(tickers[i],k);
						evalLine += signalText[(signal+1)] + ",";
					}
					bw.write("\n" + evalLine + signalText[(fitness[k]+1)].toUpperCase());
			
				}
				
			}
			bw.close();
			fw.close();
		
			
			log.debug("Total number of days: " +numDays);
		
		
		}
		catch(Exception e){
			e.printStackTrace();
		}

		
		
		
		

		
		
		
	}
	
}
