package no.ntnu.stockmeks;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.ArrayList;

import no.ntnu.stockmeks.agent.Agent;

public class StockGui implements ActionListener,MouseListener{
	//StockTerminal st;
	StockTicker ticker;
	Logger log = new Logger("StockGui");
	//Graphics g2d = new Graphics2D().create(100,100,200,200);
	JTextField tickerBox;
	//JTextField importBox;
	JTextField dayBox;
	JComboBox importBox;
	JComboBox agentList;
	//JTextField tickerBox;
	JButton tickerBoxButton;
	StockChart sc;
	JFrame frame;
	
	ArrayList<Agent> agents;
	
	
	public StockGui(){
	}
	public StockGui(ArrayList<Agent> agents){
		setAgents(agents);
	}
	
	public void setAgents(ArrayList<Agent> agents){
		this.agents = agents;
	}

	
	public JTextField createTickBox(){
		tickerBox = new JTextField();
		tickerBox.setText("fast");
		return tickerBox;
	}
	public JComboBox createImportBox(){
		String[] importValg = {"Fil","Netfonds","csv"};
		importBox = new JComboBox(importValg);
		
		//importBox = new JTextField();
		//importBox.setText("1");
		return importBox;
	}
	
	
	public JComboBox createAgentList(){

		String[] agentNames = new String[agents.size()+1];
		agentNames[0] = "-Agent?-";
		for(int i=1;i<agents.size()+1;i++){
			agentNames[i] = (agents.get(i-1).getAgentName());
		}

		return new JComboBox(agentNames);
	}

	public JTextField createDayBox(){
		dayBox = new JTextField("3000");
		return dayBox;
	}

	public JButton createTickBoxButton(){
		tickerBoxButton = new JButton();
		tickerBoxButton.setText("show");
		tickerBoxButton.setEnabled(true);
		tickerBoxButton.addMouseListener(this);
		return tickerBoxButton;
	}
	
	
	public void createAndShowGui(){
        //Create and set up the window.
		frame = new JFrame("StockMeks Technical Analyzer");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        JPanel topMenu = new JPanel(new BorderLayout());
        JLabel tickerNameLabel = new JLabel(" ");

        agentList = createAgentList();
        JPanel tickChooseLine = new JPanel(new GridLayout());
        JLabel tickLabel = new JLabel("ticker symbol: ");
        JLabel dayLabel = new JLabel("Show # days: ");
        //JLabel importLabel = new JLabel("fil (1) eller nett (2)? ");
        tickChooseLine.add(tickLabel);
        tickChooseLine.add(createTickBox());
        tickChooseLine.add(dayLabel);
        tickChooseLine.add(createDayBox());
        //tickChooseLine.add(importLabel);
        tickChooseLine.add(createImportBox());
        tickChooseLine.add(agentList);
        
        
        topMenu.add(tickerNameLabel,BorderLayout.WEST);
        topMenu.add(tickChooseLine,BorderLayout.CENTER);
        topMenu.add(createTickBoxButton(),BorderLayout.EAST);
        //frame.getContentPane().add(stockChart, BorderLayout.NORTH);
        frame.getContentPane().add(topMenu,BorderLayout.NORTH);
        
        //Graphics2D g2d = (Graphics2D)stockChart;
        //showTicker("foe");
        //ticker = new StockTicker("foe");
        //ticker.doHistoryImport(ticker.IMPORT_FROM_FILE);
        ticker = new StockTicker(tickerBox.getText());
        ticker.doHistoryImport(ticker.IMPORT_FROM_FILE);
        
        sc = new StockChart(ticker);
        //StockChart sc = new StockChart();
        sc.setVisible(true);
        sc.setSize(400,300);
        frame.getContentPane().add(sc,BorderLayout.CENTER);
        
        
        
        //Display the window.
        frame.setSize(700,500);
        frame.setVisible(true);
        
		
	}
	

	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
		if(e.getComponent().equals(tickerBoxButton)){
			//en har trykker p meksen for  oppdatere
			ticker.setTicker(tickerBox.getText());
			ticker.doHistoryImport(importBox.getSelectedIndex()+1);
			
			sc.numDays = Integer.parseInt(dayBox.getText());
			int agentChoosen = agentList.getSelectedIndex();
			if(agentChoosen>0) sc.setAgent(agents.get(agentChoosen-1));
			else sc.hideAgent();
		
			log.debug("Setter ticker til: " + tickerBox.getText());
			frame.repaint();

			
		}
		
	}

	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		
		
	}
	
	//public void showTicker(String tickername){
		//henter inn et tickernavn og oppdaterer de forskjellige delene av siden
		//ticker.setTicker(tickername);
		//ticker.doHistoryImport(ticker.IMPORT_FROM_FILE);

		
		
	//}
	
	
	
}
