package no.ntnu.stockmeks.agent;

import no.ntnu.stockmeks.StockTicker;

public class AgentAdministrator {
	StockTicker ticker;
	Agent agent;
	int[] agentSignals;
	double[] extremes;
	
	public AgentAdministrator(StockTicker ticker,Agent agent){
		this.ticker = ticker;
		this.agent = agent;
		initialize();
	}
	
	private void initialize(){
		agentSignals = agent.getSignalDays(ticker);
		extremes = ticker.getExtremeDays(5.0);
	}
	
	public int getAgentSignal(int atDay){
		return agentSignals[atDay];
	}
	
	public double getExtremeYield(int atDay){
		return extremes[atDay];
	}
	
	public int getDays(){
		return ticker.getSize();
	}
	
	public StockTicker getTicker(){
		return ticker;
	}
	public Agent getAgent(){
		return agent;
	}
	
}
