package no.ntnu.stockmeks.agent;
import no.ntnu.stockmeks.StockTicker;
import no.ntnu.stockmeks.Logger;
public class AgentHelper {

	public double simulateSpent = 0;
	public double simulateEarned = 0;
	
	final int TRANSACTION_NONE = 0;
	final int TRANSACTION_BOUGHT = 1;
	final int TRANSACTION_SHORTSOLD = 2;

	
	double simulateAmountOfMoneyUsed = 100000;
	int transactionMode = TRANSACTION_NONE; //0: ingen transaksjon, 1: kjpt, 2: short-solgt
	double simulateLastPrice = 0;
	int simulateNumberOfStocks = 0;
	int simluateTransactions = 0;

	Logger log = new Logger("AgentHelper");
	

	public AgentHelper(){
		
	}
	
	
	
	public int[] getSignalDays(Agent agent, StockTicker ticker){
		
		int[] signals = new int[ticker.getSize()];
		for(int i=0;i<ticker.getSize();i++){
			signals[i] = agent.getSignal(ticker,i);
		}
		return signals;
	}
	
	
	public double getFitness(StockTicker ticker,Agent agent){
		
		
		
		
		return 0;
	}
	
	
	public double getYield(StockTicker ticker,Agent agent,int startDay,int endDay){
		double totalYield = 0.0;
		for(int i=startDay;i<endDay;i++){
			double priceAtDay = ticker.getClose(i);
			double nextExtreme = ticker.getNextRelativeExtreme(i,5.0);
			int signalAtDay = agent.getSignal(ticker,i);
			if(signalAtDay==-1) totalYield += (-1)+(priceAtDay/nextExtreme);
			else if(signalAtDay==1) totalYield += (-1) + (nextExtreme/priceAtDay);
		}
		return totalYield;
	}
	
	
	public double simulate(StockTicker ticker,Agent agent, boolean showTransactions){
		
		
		
		simulateSpent = 0;
		simulateEarned = 0;
		
		for(int i=0;i<ticker.getSize();i++){
			int signal = agent.getSignal(ticker,i);
			if(signal==1) simulateBuy(ticker,i, showTransactions);
			else if(signal==-1) simulateSell(ticker,i,showTransactions);
			
		}
		
		if(transactionMode==TRANSACTION_SHORTSOLD) simulateBuy(ticker,(ticker.getSize()-1),showTransactions);
		else if(transactionMode==TRANSACTION_BOUGHT) simulateSell(ticker,(ticker.getSize()-1),showTransactions);
		//System.out.println("Fitness: " + (simulateEarned/simulateSpent)+ "..... Transactions: " + nofTransactions + " and not:" + nofNotTransactions);
		
		if(simulateSpent>0) return (simulateEarned/simulateSpent);
		else return 0;
	}
	
	
	
	public double simulate(StockTicker ticker,Agent agent){
		return simulate(ticker,agent,false);
	}
	
	
	
	
	
	private void simulateBuy(StockTicker ticker, int atDay, boolean printTransactions){
		if(transactionMode==TRANSACTION_SHORTSOLD){
			double buyTick = ticker.getClose(atDay); 
			double buyPrice = simulateNumberOfStocks * buyTick;
			simulateSpent += buyPrice;
			
			if(printTransactions) System.out.println("Buying back shortsold day "+ atDay+ ": " + buyTick+ ". Total: " + buyPrice);
			transactionMode = TRANSACTION_NONE;
		}
		else if(transactionMode==TRANSACTION_NONE){
			double buyingAtPrice = ticker.getClose(atDay);
			simulateNumberOfStocks = (int)Math.round(simulateAmountOfMoneyUsed/buyingAtPrice);
			
			if(printTransactions) System.out.println("Buying at day "+ atDay+ ": " + buyingAtPrice +". Total: " + (simulateNumberOfStocks*buyingAtPrice));

			simulateSpent += (simulateNumberOfStocks*buyingAtPrice);
			transactionMode = TRANSACTION_BOUGHT;
		}
	}

	private void simulateSell(StockTicker ticker, int atDay,boolean printTransactions){
		if(transactionMode==TRANSACTION_BOUGHT){
			double sellTick = ticker.getClose(atDay);
			double sellPrice = simulateNumberOfStocks * sellTick;
			simulateEarned += sellPrice;
			if(printTransactions) System.out.println("Selling bought at day "+ atDay+ ": " + sellTick + ". Total: " + sellPrice);

			transactionMode = TRANSACTION_NONE;
		}
		else if(transactionMode==TRANSACTION_NONE){
			//short selling
			double sellingAtPrice = ticker.getClose(atDay);
			simulateNumberOfStocks = (int)Math.round(simulateAmountOfMoneyUsed/sellingAtPrice);
			simulateEarned += (sellingAtPrice*simulateNumberOfStocks);
			if(printTransactions) System.out.println("Short selling at day "+ atDay+ ": " + sellingAtPrice + ". Total: " + (sellingAtPrice*simulateNumberOfStocks));
			transactionMode = TRANSACTION_SHORTSOLD;
		}
	}	
	
}
