package no.ntnu.stockmeks.agent;



import no.ntnu.stockmeks.StockTicker;
import no.ntnu.stockmeks.agent.trees.*;

public class ID3TreeAgent implements Agent {


		
	Agent[] agents;
	
	ID3Leafs leafs;
	ID3Agents agentsNumbers;
	ID3Evals evals;
	ID3Signals signals;
	
	public ID3TreeAgent(Agent[] agents){
		this.agents = agents;

		//definition of leaves, signals etc habe been moved to external objects because of
		//memory shortage!
		leafs = new ID3Leafs();
		agentsNumbers = new ID3Agents();
		evals = new ID3Evals();
		signals = new ID3Signals();
		
	}
	
	public String getAgentName() {
		return "ID3 Tree";
	}

	public int getSignal(StockTicker ticker) {
		return getSignal(ticker,ticker.getSize()-1);
	}
	
	

	public int getSignal(StockTicker ticker, int atDayNumber) {
		
		
		int atLevel = 0;
		for(int i=0;i<8766;i++){
			if(leafs.get(i)==atLevel){
				//are at the correct level of the tree
				if(agents[agentsNumbers.getAt(i)].getSignal(ticker,atDayNumber)==evals.getAt(i)){
					if(signals.getAt(i)==-2){
						atLevel++;
					}
					else{
						//we have an evaluated signal!
						return signals.getAt(i);
					}
				}
			}
		}
		return SIGNAL_HOLD;
	}


	public int[] getSignalDays(StockTicker ticker) {
		return helper.getSignalDays(this,ticker);
	}

}
