package no.ntnu.stockmeks.agent;
import no.ntnu.stockmeks.StockTicker;

public class IslandReversalAgent implements Agent{

	GAPAgent gap1;
	GAPAgent gap2;
	
	int maxNumDaysBetweenGaps = 5;
	double gapPercent = -0.01;
	int numDaysWithGap = 0;
	int daysPrecedingGap = 0;

	
	public int[] getSignalDays(StockTicker ticker) {
		return helper.getSignalDays(this,ticker);
	}

	
	public IslandReversalAgent(){
		gap1 = new GAPAgent(0,gapPercent,daysPrecedingGap);
		gap2 = new GAPAgent(numDaysWithGap,gapPercent,0);
	}
	
	
	public String getAgentName() {
		//" + gapPercent + "% " + numDaysWithGap +"";
		return "Island Reversal";
	}

	public int getSignal(StockTicker ticker) {
		return getSignal(ticker,ticker.getSize()-1);
	}

	public int getSignal(StockTicker ticker,int atDayNumber) {
		boolean irUp = false;
		boolean irDown = false;
		
		for(int i=atDayNumber-maxNumDaysBetweenGaps;i<=(atDayNumber) && i<=ticker.getSize();i++){
			for(int j=i;j<(atDayNumber) && j<=ticker.getSize();j++){
				//log.debug("i: " + i + ", j:" + j);
				int gap1signal = gap1.getSignal(ticker,i);
				int gap2signal = gap2.getSignal(ticker,j);
				
				if(gap1signal==SIGNAL_BUY){
					if(gap2signal==SIGNAL_SELL) irDown = true;
				}
				else if(gap1signal==SIGNAL_SELL){
					if(gap2signal==SIGNAL_BUY) irUp = true;
				}
			}
			
		}
		if(irDown && !irUp) return SIGNAL_SELL;
		else if(!irDown && irUp) return SIGNAL_BUY;
		else return SIGNAL_HOLD;
	}
		


}
