package no.ntnu.stockmeks.agent;

import no.ntnu.stockmeks.StockTicker;

public class JanuaryAgent implements Agent{
	IndexInfo osebx = new IndexInfo();
	int[] upYears = {1971,1972,1974,1975,1976,1978,1979,1980,1982,1983,1984,1985,1986,1988,1989,1990,1991,1992,1993,1995,1996,1997,1998,1999,2003,2004,2005,2006};

	public String getAgentName() {
		return "January Effect";
	}

	public int getSignal(StockTicker ticker) {
		return getSignal(ticker,ticker.getSize()-1);
	}

	public int getSignal(StockTicker ticker, int atDayNumber) {
		if(atDayNumber<0) return SIGNAL_ERROR;
		if(ticker.getMonth(atDayNumber)==12){
			int thisYear = ticker.getYear(atDayNumber);
			boolean wasUp = false;
			
			for(int i=0;i<upYears.length;i++){
				if(upYears[i]==thisYear) wasUp = true;
			}

			//year not defined by array, need to be checked
			if(ticker.getYear(atDayNumber)>2007){
				wasUp = osebx.wasUpYear(ticker.getYear(atDayNumber));
			}
			
			if(wasUp) return SIGNAL_BUY;
			else return SIGNAL_HOLD;
		}
		else return SIGNAL_HOLD;
	}


	public int[] getSignalDays(StockTicker ticker) {
		return helper.getSignalDays(this,ticker);
	}

}
