package no.ntnu.stockmeks.agent;
import no.ntnu.stockmeks.StockTicker;

public class MaCrossoverAgent implements Agent{

	MAAgent maShortTerm;
	MAAgent maLongTerm;

	int shortTermDays = 10;
	int longTermDays = 100;
	
	int numDaysCrossed = 5;

	public int[] getSignalDays(StockTicker ticker) {
		return helper.getSignalDays(this,ticker);
	}


	
	public MaCrossoverAgent(){
		setMaAgents();
	}
	public MaCrossoverAgent(int shortDays,int longDays){
		this.shortTermDays = shortDays;
		this.longTermDays = longDays;
		setMaAgents();
	}
	
	public void setMaAgents(){
		maShortTerm = new MAAgent();
		maLongTerm = new MAAgent();
		
		maShortTerm.setValues(shortTermDays,1);
		maLongTerm.setValues(longTermDays,1);
	}

	
	public String getAgentName() {
		return "Crossover MA " + shortTermDays + "-" + longTermDays;
	}

	public int getSignal(StockTicker ticker) {
		return getSignal(ticker,ticker.getSize()-1);
	}

	public int getSignal(StockTicker ticker,int atDayNumber) {
		if(atDayNumber<numDaysCrossed || atDayNumber>=ticker.getSize()) return SIGNAL_ERROR;
		
		int trend = 0; //0: first, 1=up, 2=down
		double maShort = ticker.getClose(atDayNumber-1);
		double maLong = ticker.getClose(atDayNumber);
		if(maShort>maLong) trend = 2;
		else if(maShort<maLong) trend = 1;
		
		boolean trendIsSame = true;
		
		for(int i=atDayNumber-numDaysCrossed+1;i<=atDayNumber;i++){
			maShort = maShortTerm.calculateMa(ticker,i);
			maLong = maLongTerm.calculateMa(ticker,i);
			if(trend==1 && maShort>maLong) trendIsSame = false;
			else if(trend==2 && maShort<maLong) trendIsSame = false;
		}
		
		if(trendIsSame){
			if(trend==1) return SIGNAL_SELL;
			else return SIGNAL_BUY;
		}
		else return SIGNAL_HOLD; 
	}



	
	

}
