package no.ntnu.stockmeks.agent;

import no.ntnu.stockmeks.StockTicker;

/*
 * Agent to illustrate how optimal trading is,
 * not to be used as indicator!
 */
public class OptimalAgent implements Agent {

	public String getAgentName() {
		return "Optimal";
	}

	public int getSignal(StockTicker ticker) {
		return getSignal(ticker,ticker.getSize()-1);
	}

	public int getSignal(StockTicker ticker, int atDayNumber) {
		double thisDay = ticker.getClose(atDayNumber);
		double nextExtreme = ticker.getNextRelativeExtreme(atDayNumber,5.0);
		double percentageHigher = thisDay / nextExtreme;
		
		if(percentageHigher>1.14) return SIGNAL_SELL;
		else if(percentageHigher<0.86) return SIGNAL_BUY;
		else return SIGNAL_HOLD;
	}


	public int[] getSignalDays(StockTicker ticker) {
		return helper.getSignalDays(this,ticker);
	}

}
