package no.ntnu.stockmeks.agent;

import no.ntnu.stockmeks.StockTicker;

public class ReversalDayAgent implements Agent{

	double upMoveMinimum = 0.03;
	double belowMinimum = 0.00;
	
	public String getAgentName() {
		return "Reversal day";
	}

	public int getSignal(StockTicker ticker) {
		return getSignal(ticker,ticker.getSize()-1);
	}

	public int getSignal(StockTicker ticker, int atDayNumber) {
		int direction = checkReversal(ticker,atDayNumber);
		if(direction<0) return SIGNAL_SELL;
		else if(direction>0) return SIGNAL_BUY;
		else return SIGNAL_HOLD;
	}

	public int[] getSignalDays(StockTicker ticker) {
		return helper.getSignalDays(this,ticker);
	}
	
	public int checkReversal(StockTicker ticker, int atDay){
		int direction = 0;
		
		if(atDay<1) return direction;
		
		double toDayClose = ticker.getClose(atDay);
		double toDayHigh = ticker.getHigh(atDay);
		double toDayLow = ticker.getLow(atDay);
		
		double yesterDayClose = ticker.getClose(atDay-1);
		double yesterDayLow = ticker.getLow(atDay-1);
		double yesterDayHigh = ticker.getHigh(atDay-1);
		
		
		
		if(toDayHigh>(yesterDayClose*(1.00+upMoveMinimum))){
			//have risen higher
			if(toDayClose<yesterDayLow*(1.00-belowMinimum)){
				direction--;
			}
		}
		if(toDayLow<(yesterDayClose*(1.00-upMoveMinimum))){
			if(toDayClose>yesterDayHigh*(1.00+belowMinimum)){
				direction++;
			}
		}
		
		return direction;
		
	}
	

}
