package no.ntnu.stockmeks.agent;

import no.ntnu.stockmeks.StockTicker;
public class VolumeAgent implements Agent{

	double percent = 200.0; //how much higher volume than usual needed
	int numDays = 20; //measure from number of days
	
	public String getAgentName() {
		return "Volume";
	}

	public int getSignal(StockTicker ticker) {
		return getSignal(ticker,ticker.getSize()-1);
	}

	public int getSignal(StockTicker ticker, int atDayNumber) {
		if(atDayNumber<numDays) return SIGNAL_HOLD;
		
		long totalVolume = 0;
		for(int i=atDayNumber-numDays;i<atDayNumber;i++){
			totalVolume += ticker.getVolume(i);
		}
		
		double meanVolume = ((totalVolume)/(double)numDays);
		double previousDay = ticker.getClose(atDayNumber-1);
		double thisDay = ticker.getClose(atDayNumber);

		double threshold = (meanVolume*((100.00+percent)/100.00));
		long volumeToday = ticker.getVolume(atDayNumber);
		
		
		if(previousDay<thisDay){
			if(volumeToday>threshold) return SIGNAL_BUY;
			else return SIGNAL_HOLD;
		}
		else if(previousDay>thisDay){
			if(volumeToday>threshold) return SIGNAL_SELL;
			else return SIGNAL_HOLD;
		}
		else return SIGNAL_HOLD;
	}


	public int[] getSignalDays(StockTicker ticker) {
		return helper.getSignalDays(this,ticker);
	}
}
