package no.ntnu.stockmeks.agent;

import no.ntnu.stockmeks.StockTicker;
//import no.ntnu.stockmeks.StockTerminal;
//import java.util.ArrayList;
public class VotingClassifierAgent implements Agent {

	String name = "";
	int[] weights;
	Agent[] agents;
	
	int days = 0;
	VotingClassifierAgent zeroDaysAgent;
	

	
	public VotingClassifierAgent(Agent[] agents, int[] weights){
		this.agents = agents;
		this.weights = weights;
	}

	public VotingClassifierAgent(Agent[] agents, int[] weights, String name){
		this.agents = agents;
		this.weights = weights;
		this.name = name;
	}
	
	public void setDays(int days){
		this.days = days;
		zeroDaysAgent = new VotingClassifierAgent(agents,weights);
	}
	
	public String getAgentName() {
		if(name.equals("")){
			return "Voting Classifier";
		}
		else return "Voting Classifier " + name;
	}

	public int getSignal(StockTicker ticker) {
		return getSignal(ticker,ticker.getSize()-1);
	}

	public int getSignal(StockTicker ticker, int atDayNumber) {
		if(weights.length!=agents.length){
			return SIGNAL_ERROR;
		}
		
		if(days>0){
			if((atDayNumber-days)<0){
				return SIGNAL_ERROR;
			}
			else{
				int signal = zeroDaysAgent.getSignal(ticker,atDayNumber);
				boolean isTheSameEachDay = true;
				for(int i=(atDayNumber-1);i>=(atDayNumber-days);i--){
					if(zeroDaysAgent.getSignal(ticker,i)!=signal){
						isTheSameEachDay = false;
					}
				}
				if(isTheSameEachDay) return signal;
				else return SIGNAL_HOLD;
			}
		}
		else{
			double totalSignal = 0.0;
			int totalCounting = 0;
			for(int i=0;i<agents.length;i++){
				int signal = agents[i].getSignal(ticker,atDayNumber);
				
				if(signal!=0){
					totalSignal += ((signal * weights[i]));
					if(weights[i]<0) totalCounting += ((-1)*weights[i]);
					else totalCounting += weights[i];
					
					
				}
			}
			
			if(totalCounting==0) return SIGNAL_HOLD;
			
			double votes = totalSignal/(double)totalCounting;
			
			if(votes>0.5) return SIGNAL_BUY;
			else if(votes<-0.5) return SIGNAL_SELL;
			else return SIGNAL_HOLD;
		}
		
		
	}


	public int[] getSignalDays(StockTicker ticker) {
		return helper.getSignalDays(this,ticker);
	}
	

}
