package no.ntnu.stockmeks.tools;

import java.io.*;
//import java.util.Calendar;
public class DataCleaner {

	public void writeCleaned(double[] data){
		double[] extremes = returnHighestAndLowest(data);
		
		String toPrint = "";
		for(int i=0;i<data.length;i++){
			double cleanedValue = ((data[i]-extremes[1])/(extremes[0]-extremes[1]));
			toPrint += cleanedValue + " ";
		}
		System.out.println(toPrint);
		System.out.println("Total of: " + data.length + " data");
		
		
	}
	
	public double[] returnHighestAndLowest(double[] data){
		double extremes[] = {0.00,999999999999999.99};
		for(int i=0;i<data.length;i++){
			if(data[i]>extremes[0]) extremes[0] = data[i];
			if(data[i]<extremes[1]) extremes[1] = data[i];
		}
		return extremes;
	}
	
	public void fixString(){
		String fiks = "23-Apr-01,63.50,63.70,61.40,62.80,3159700,56.53";
		String meks = fiks.substring(fiks.lastIndexOf(",")+1);
		System.out.println("meks:" + meks+".");
	}
	
	
	public double[] getDataFromString(String datatext){
		String[] eachline = datatext.split("\n");
		
		double[] data = new double[52];
		
		for(int i=1;i<eachline.length && i<53;i++){
			String dataString = eachline[i].substring(eachline[i].lastIndexOf(",")+1);
			data[i-1] = Double.parseDouble(dataString);
		}
		return data;
		
		
	}
	
	public double getPriceFromDataLine(String line){
		String dataString = line.substring(line.lastIndexOf(",")+1);
		return Double.parseDouble(dataString);
	}

	public double[] readDataFile(String filename){
		double[] data = new double[52];
		try{
			FileReader fr = new FileReader("D:\\dipp\\nnetTraining\\"+filename);
			BufferedReader br = new BufferedReader(fr);
			String fc = "";
			fc = br.readLine(); //frste linje med info
			//fc = br.readLine(); //frste linje med info
			
			int i=0;
			while(fc != null && i<52) {
				data[i] = getPriceFromDataLine(br.readLine());
				i++;
			}
			fr.close();
		
		} catch (IOException ioe){
			ioe.printStackTrace();
			
		} catch (Exception e){
			 e.printStackTrace();
		}
		return data;

		
		
	}
	
	
		
	
	public static void main(String[] args){
		DataCleaner dc = new DataCleaner();
		double[] data = {200,193,192,195,180,180,180,185,168,210,245,260,262,290,295,320,270,320,330,340,335,333,300,310,305,295,290,300,308,315,320,305,305,303,318,301,310,315,310,340,344,350,365,380,360,365,375,360,350,345,340,335};
		dc.writeCleaned(data);
	}
	
}
