package no.ntnu.stockmeks.tools;

import java.io.*;


/*
 * Class making a decision tree array from a weka-made file
 */
public class TreeMaker {

	
	public static void main(String[] args){
		TreeMaker t = new TreeMaker();
		t.fix48TreeFile("tre-j48-s.txt");
	}
	
	public String fix48TreeFile(String filename){
		String tree = "";
		String treeWidths = "";
		String treeAgents = "";
		String treeEvals = "";
		String treeResults = "";
		
		try{
			FileReader fr = new FileReader(filename);
			BufferedReader br = new BufferedReader(fr);

			FileWriter fw = new FileWriter("tre-fikset.txt");
			BufferedWriter bw = new BufferedWriter(fw);
			
			
			String fc = "";
			fc = br.readLine(); //frste linje med info
			
			while(fc != null) {
				String treeLine = fc;
				int leaf = treeLine.lastIndexOf("|  ");
				int numLeafs = 0;
				if(leaf>-1){
					numLeafs = (leaf+4)/(4);
				}
				else leaf = -3;
				String evalPart = treeLine.substring(leaf+3);
				String[] evaluation = evalPart.split(" = ");
				treeAgents += evaluation[0]+",";
				treeWidths += numLeafs+",";
				if(evaluation[1].indexOf(":")<0){
					treeEvals += evaluation[1]+",";
					treeResults += "-2,";
				}
				else{
					String[] evalResult = evaluation[1].split(": ");
					treeEvals += evalResult[0]+",";
					
					
					String[] evalValuation = evalResult[1].split(" ");
					if(evalValuation[1].equals("(-0.0)")){
						treeResults += "0,";
					}
					else treeResults += evalValuation[0]+",";
					
				}
								
				fc = br.readLine();
			}
			
			
			bw.write("int[] numLeafs = {" + treeWidths.substring(0,treeWidths.length()-1) + "};\n");
			bw.write("int[] agentNumbers = {" + treeAgents.substring(0,treeAgents.length()-1) + "};\n");
			bw.write("int[] eval = {" + treeEvals.substring(0,treeEvals.length()-1) + "};\n");
			bw.write("int[] signals = {" + treeResults.substring(0,treeResults.length()-1) + "};\n");
			
			bw.close();
			fw.close();
			
			br.close();
			fr.close();
			
		
		} catch (IOException ioe){
			ioe.printStackTrace();
			
		} catch (Exception e){
			 e.printStackTrace();
		}
		return tree;
	}

	
	
	public String fixTreeFile(String filename){
		String tree = "";
		String treeWidths = "";
		String treeAgents = "";
		String treeEvals = "";
		String treeResults = "";
		
		try{
			FileReader fr = new FileReader(filename);
			BufferedReader br = new BufferedReader(fr);

			FileWriter fw = new FileWriter("tre-fikset.txt");
			BufferedWriter bw = new BufferedWriter(fw);
			
			
			String fc = "";
			fc = br.readLine(); //frste linje med info
			
			while(fc != null) {
				String treeLine = fc;
				int leaf = treeLine.lastIndexOf("|  ");
				int numLeafs = 0;
				if(leaf>-1){
					numLeafs = leaf/3;
					numLeafs++;
				}
				else leaf = -3;
				String evalPart = treeLine.substring(leaf+3);
				String[] evaluation = evalPart.split(" = ");
				treeAgents += evaluation[0]+",";
				treeWidths += numLeafs+",";
				if(evaluation[1].indexOf(":")<0){
					//ingen evaluation
					treeEvals += evaluation[1]+",";
					treeResults += "-2,";
				}
				else{
					String[] evalResult = evaluation[1].split(": ");
					treeEvals += evalResult[0]+",";
					treeResults += evalResult[1]+",";
				}
				
				
				//bw.write(numLeafs + "," + eval + ",");
				fc = br.readLine();
			}
			
			
			bw.write("int[] numLeafs = {" + treeWidths.substring(0,treeWidths.length()-1) + "};\n");
			bw.write("int[] agentNumbers = {" + treeAgents.substring(0,treeAgents.length()-1) + "};\n");
			bw.write("int[] eval = {" + treeEvals.substring(0,treeEvals.length()-1) + "};\n");
			bw.write("int[] signals = {" + treeResults.substring(0,treeResults.length()-1) + "};\n");
			
			bw.close();
			fw.close();
			
			br.close();
			fr.close();
			
		
		} catch (IOException ioe){
			ioe.printStackTrace();
			
		} catch (Exception e){
			 e.printStackTrace();
		}
		return tree;
	}

	
}
